Python的异常处理

in 互联网技术 with 1 comment  访问: 995 次

1、异常处理基础

在编程过程中为了增加友好性,在程序出现bug时一般不会将错误信息直接显示给用户,而是更友好的给出一个提示的页面,通俗来说就是不让用户不知所措,使得报错更友好、更清晰。

try:
    pass
except Exception as e:
    pass

实例:

Python2:

#!/usr/bin/env  python
#-*- coding: utf8 -*-
while True:
    num1 = raw_input('num1:')
    num2 = raw_input('num2:')
    print(type(num1), type(num2))

    try:
        num1 = int(num1)
        num2 = int(num2)
        result = num1 + num2
        print(result)
    except Exception, e:
        print '出现异常,细化错误如下:' 
        print e 

Python3:

#!/usr/bin/env python3
#-*- coding: utf8 -*-

while True:
    num1 = input('num1:')
    num2 = input('num2:')
    print(type(num1), type(num2))

    try:
        num1 = int(num1)
        num2 = int(num2)
        result = num1 + num2
        print(result)

    except Exception as e:
        print('出现异常,细化错误如下:')
        print(e)

处理异常的三种方法参考:http://openskill.cn/article/436

2、异常的情况

Python中异常的情况非常多,每个异常专门用来处理某一项异常。

常用异常:

AttributeError 试图访问一个对象没有的树形,比如foo.x,但是foo没有属性x
IOError 输入/输出异常;基本上是无法打开文件
ImportError 无法引入模块或包;基本上是路径问题或名称错误
IndentationError 语法错误(的子类) ;代码没有正确对齐
IndexError 下标索引超出序列边界,比如当x只有三个元素,却试图访问x[5]
KeyError 试图访问字典里不存在的键
KeyboardInterrupt Ctrl+C被按下
NameError 使用一个还未被赋予对象的变量
SyntaxError Python代码非法,代码不能编译(个人认为这是语法错误,写错了)
TypeError 传入对象类型与要求的不符合
UnboundLocalError 试图访问一个还未被设置的局部变量,基本上是由于另有一个同名的全局变量,
导致你以为正在访问它
ValueError 传入一个调用者不期望的值,即使值的类型是正确的

更多异常

ArithmeticError
AssertionError
AttributeError
BaseException
BufferError
BytesWarning
DeprecationWarning
EnvironmentError
EOFError
Exception
FloatingPointError
FutureWarning
GeneratorExit
ImportError
ImportWarning
IndentationError
IndexError
IOError
KeyboardInterrupt
KeyError
LookupError
MemoryError
NameError
NotImplementedError
OSError
OverflowError
PendingDeprecationWarning
ReferenceError
RuntimeError
RuntimeWarning
StandardError
StopIteration
SyntaxError
SyntaxWarning
SystemError
SystemExit
TabError
TypeError
UnboundLocalError
UnicodeDecodeError
UnicodeEncodeError
UnicodeError
UnicodeTranslateError
UnicodeWarning
UserWarning
ValueError
Warning
ZeroDivisionError

参考:https://docs.python.org/3/library/exceptions.html#bltin-exceptions

实例:IndexError

lis = [ "dog", "cat" ]
try:
    lis[8]
except IndexError as e:
    print('IndexError content is: %s' % e)

实例:KeyError

dic = {'age': 18, 'job': 'IT'}
try:
    dic['name']
except KeyError as e:
    print('KeyError conten is: %s' % e)

实例:ValueError

s = 'hello'
try:
    int(s)
except ValueError as e:
    print("ValueError content is: %s" % e)

对于上述实例,异常类只能用来处理指定的异常情况,如果非指定异常则无法处理。

# 未捕获到异常,程序直接报错

s = 'hello'
try:
    int(s)
except IndexError as e:
    print(e)

所以,写程序时需要考虑到try代码块中可能出现的任意异常,可以这样写:

s = 'hello'
try:
    int(s)
except IndexError as e:
    print(e)
except KeyError as e:
    print(e)
except ValueError as e:
    print(e)

万能异常 在python的异常中,有一个万能异常:Exception,他可以捕获任意异常,即:

s = 'hello'
try:
    int(s)
except Exception as e:
    print(e)

接下来你可能要问了,既然有这个万能异常,其他异常是不是就可以忽略了!

答:当然不是,对于特殊处理或提醒的异常需要先定义,最后定义Exception来确保程序正常运行。

s = 'hello'
try:
    int(s)
except KeyError as e:
    print('键错误')
except IndexError as e:
    print('索引错误')
except Exception as e:
    print('Unknown Error')

3、异常其他结构

try:
    # 主代码块
    pass
except KeyError,e:
    # 异常时,执行该块
    pass
else:
    # 主代码块执行完,执行该块
    pass
finally:
    # 无论异常与否,最终执行该块
    pass

4、主动触发异常

raise 语句允许程序员强制抛出一个指定的异常。例如:

>>> raise NameError('HiThere')
Traceback (most recent call last):
  File "<stdin>", line 1, in ?
NameError: HiThere

要抛出的异常由 raise 的唯一参数标识。它必需是一个异常实例或异常类(继承自 Exception 的类)。

如果你需要明确一个异常是否抛出,但不想处理它,raise 语句可以让你很简单的重新抛出该异常:

>>> try:
...     raise NameError('HiThere')
... except NameError:
...     print('An exception flew by!')
...     raise
...
An exception flew by!
Traceback (most recent call last):
  File "<stdin>", line 2, in ?
NameError: HiThere

5、自定义异常

在程序中可以通过创建新的异常类型来命名自己的异常。异常类通常应该直接或间接的从 Exception 类派生,例如:

class NockException(Exception):
    def __init__(self, msg):
        self.message = msg

    def __str__(self):
        return self.message

try:
    raise NockException('我的异常')
except NockException as e:
            print(e)

参考: http://www.pythondoc.com/pythontutorial3/errors.html

WeZan
Responses
  1. File is Good

    Reply